sidebarNodes={"extras":[{"id":"api-reference","title":"API Reference","group":"","headers":[{"id":"Modules","anchor":"modules"},{"id":"About Components","anchor":"about-components"},{"id":"Overview","anchor":"overview"},{"id":"Overview","anchor":"overview"},{"id":"Exceptions","anchor":"exceptions"},{"id":"Mix Tasks","anchor":"mix-tasks"}]},{"id":"upgrading_to_v0-10","title":"Upgrading to v0.10","group":"","headers":[{"id":"Overview","anchor":"overview"},{"id":"Changes to the Cache","anchor":"changes-to-the-cache"},{"id":"Static vs. Dynamic Caches","anchor":"static-vs-dynamic-caches"},{"id":"Deprecation of push_graph()","anchor":"deprecation-of-push_graph"}]},{"id":"welcome","title":"Scenic","group":"","headers":[{"id":"Upgrading to v0.10","anchor":"upgrading-to-v0-10"},{"id":"How to get started?","anchor":"how-to-get-started"}]},{"id":"install_dependencies","title":"Install Dependencies","group":"","headers":[{"id":"On MacOS","anchor":"on-macos"},{"id":"On Ubuntu 16","anchor":"on-ubuntu-16"},{"id":"On Ubuntu 18","anchor":"on-ubuntu-18"},{"id":"On Fedora","anchor":"on-fedora"},{"id":"On Archlinux","anchor":"on-archlinux"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"overview_general","title":"General Overview","group":"","headers":[{"id":"Goals","anchor":"goals"},{"id":"Non-Goals","anchor":"non-goals"},{"id":"Architecture","anchor":"architecture"},{"id":"Mental Model","anchor":"mental-model"},{"id":"Terms and Definitions","anchor":"terms-and-definitions"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"getting_started","title":"Getting Started","group":"","headers":[{"id":"Install scenic.new","anchor":"install-scenic-new"},{"id":"Build the Basic App","anchor":"build-the-basic-app"},{"id":"Build the Example App","anchor":"build-the-example-app"},{"id":"Configure Scenic","anchor":"configure-scenic"},{"id":"Running and Debugging","anchor":"running-and-debugging"},{"id":"The Starter App","anchor":"the-starter-app"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"getting_started_nerves","title":"Getting Started with Nerves","group":"","headers":[{"id":"Install scenic.new","anchor":"install-scenic-new"},{"id":"Create the Basic Nerves App","anchor":"create-the-basic-nerves-app"},{"id":"Build and Run on Your Dev Machine","anchor":"build-and-run-on-your-dev-machine"},{"id":"Build and Run on a Raspberry Pi 3","anchor":"build-and-run-on-a-raspberry-pi-3"},{"id":"Supported Devices","anchor":"supported-devices"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"overview_scene","title":"Structure of a Scene","group":"","headers":[{"id":"The Graph","anchor":"the-graph"},{"id":"Initialization","anchor":"initialization"},{"id":"Pushing a Graph","anchor":"pushing-a-graph"},{"id":"User Input","anchor":"user-input"},{"id":"Events","anchor":"events"},{"id":"Components","anchor":"components"},{"id":"Adding Components to a Parent Scene","anchor":"adding-components-to-a-parent-scene"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"scene_lifecycle","title":"Life-cycle of a Scene","group":"","headers":[{"id":"The Root Scene","anchor":"the-root-scene"},{"id":"Dynamically Supervised Scenes","anchor":"dynamically-supervised-scenes"},{"id":"App Supervised Scenes","anchor":"app-supervised-scenes"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"overview_graph","title":"Graph Overview","group":"","headers":[{"id":"Primitives","anchor":"primitives"},{"id":"Styles","anchor":"styles"},{"id":"Transforms","anchor":"transforms"},{"id":"Modifying a graph","anchor":"modifying-a-graph"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"overview_viewport","title":"ViewPort Overview","group":"","headers":[]},{"id":"overview_driver","title":"Driver Overview","group":"","headers":[]},{"id":"overview_styles","title":"Styles Overview","group":"","headers":[{"id":"Primitive Styles","anchor":"primitive-styles"},{"id":"Primitive Paint Styles","anchor":"primitive-paint-styles"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"overview_transforms","title":"Transforms Overview","group":"","headers":[{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"overview_primitives","title":"Primitives Overview","group":"","headers":[{"id":"Using Primitives","anchor":"using-primitives"},{"id":"Styles","anchor":"styles"},{"id":"Transforms","anchor":"transforms"},{"id":"Modifying a Primitive","anchor":"modifying-a-primitive"},{"id":"What to read next?","anchor":"what-to-read-next"}]},{"id":"overview_cache","title":"Cache Overview","group":"","headers":[{"id":"Asset Types","anchor":"asset-types"},{"id":"Static vs. Dynamic assets","anchor":"static-vs-dynamic-assets"},{"id":"Custom Asset Types","anchor":"custom-asset-types"},{"id":"Adding Custom Fonts","anchor":"adding-custom-fonts"}]},{"id":"custom_fonts","title":"Using Custom Fonts","group":"","headers":[{"id":"Add the custom font file","anchor":"add-the-custom-font-file"},{"id":"Generate the \*.metrics file","anchor":"generate-the-metrics-file"},{"id":"Load the \*.metrics file and the font into the cache","anchor":"load-the-metrics-file-and-the-font-into-the-cache"},{"id":"Refer to the font by the metrics key","anchor":"refer-to-the-font-by-the-metrics-key"}]},{"id":"code_of_conduct","title":"Contributor Code of Conduct","group":"","headers":[]},{"id":"contributing","title":"Contributing to Scenic","group":"","headers":[{"id":"Components","anchor":"components"},{"id":"Using the issue tracker","anchor":"using-the-issue-tracker"},{"id":"Bug reports","anchor":"bug-reports"},{"id":"Feature requests","anchor":"feature-requests"},{"id":"Contributing Documentation","anchor":"contributing-documentation"},{"id":"Pull requests","anchor":"pull-requests"},{"id":"Guides","anchor":"guides"}]}],"exceptions":[{"id":"Scenic.Cache.Base.Error","title":"Scenic.Cache.Base.Error","group":""},{"id":"Scenic.Primitive.Style.FormatError","title":"Scenic.Primitive.Style.FormatError","group":""},{"id":"Scenic.ViewPort.Driver.Error","title":"Scenic.ViewPort.Driver.Error","group":""}],"modules":[{"id":"Scenic","title":"Scenic","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"version/0","anchor":"version/0"}]}]},{"id":"Scenic.Components","title":"Scenic.Components","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"button/3","anchor":"button/3"},{"id":"button_spec/2","anchor":"button_spec/2"},{"id":"checkbox/3","anchor":"checkbox/3"},{"id":"checkbox_spec/2","anchor":"checkbox_spec/2"},{"id":"dropdown/3","anchor":"dropdown/3"},{"id":"dropdown_spec/2","anchor":"dropdown_spec/2"},{"id":"radio_group/3","anchor":"radio_group/3"},{"id":"radio_group_spec/2","anchor":"radio_group_spec/2"},{"id":"slider/3","anchor":"slider/3"},{"id":"slider_spec/2","anchor":"slider_spec/2"},{"id":"text_field/3","anchor":"text_field/3"},{"id":"text_field_spec/2","anchor":"text_field_spec/2"},{"id":"toggle/3","anchor":"toggle/3"},{"id":"toggle_spec/2","anchor":"toggle_spec/2"}]}]},{"id":"Scenic.Graph","title":"Scenic.Graph","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"deferred/0","anchor":"t:deferred/0"},{"id":"key/0","anchor":"t:key/0"},{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"add/2","anchor":"add/2"},{"id":"add/4","anchor":"add/4"},{"id":"build/1","anchor":"build/1"},{"id":"count/1","anchor":"count/1"},{"id":"count/2","anchor":"count/2"},{"id":"delete/2","anchor":"delete/2"},{"id":"find/2","anchor":"find/2"},{"id":"get/2","anchor":"get/2"},{"id":"get!/2","anchor":"get!/2"},{"id":"map/2","anchor":"map/2"},{"id":"map/3","anchor":"map/3"},{"id":"modify/3","anchor":"modify/3"},{"id":"reduce/3","anchor":"reduce/3"},{"id":"reduce/4","anchor":"reduce/4"}]}]},{"id":"Scenic.Primitives","title":"Scenic.Primitives","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add_specs_to_graph/2","anchor":"add_specs_to_graph/2"},{"id":"add_specs_to_graph/3","anchor":"add_specs_to_graph/3"},{"id":"arc/3","anchor":"arc/3"},{"id":"arc_spec/2","anchor":"arc_spec/2"},{"id":"circle/3","anchor":"circle/3"},{"id":"circle_spec/2","anchor":"circle_spec/2"},{"id":"ellipse/3","anchor":"ellipse/3"},{"id":"ellipse_spec/2","anchor":"ellipse_spec/2"},{"id":"group/3","anchor":"group/3"},{"id":"group_spec/2","anchor":"group_spec/2"},{"id":"line/3","anchor":"line/3"},{"id":"line_spec/2","anchor":"line_spec/2"},{"id":"path/3","anchor":"path/3"},{"id":"path_spec/2","anchor":"path_spec/2"},{"id":"quad/3","anchor":"quad/3"},{"id":"quad_spec/2","anchor":"quad_spec/2"},{"id":"rect/3","anchor":"rect/3"},{"id":"rect_spec/2","anchor":"rect_spec/2"},{"id":"rectangle/3","anchor":"rectangle/3"},{"id":"rectangle_spec/2","anchor":"rectangle_spec/2"},{"id":"rounded_rectangle/3","anchor":"rounded_rectangle/3"},{"id":"rounded_rectangle_spec/2","anchor":"rounded_rectangle_spec/2"},{"id":"rrect/3","anchor":"rrect/3"},{"id":"rrect_spec/2","anchor":"rrect_spec/2"},{"id":"scene_ref/3","anchor":"scene_ref/3"},{"id":"scene_ref_spec/2","anchor":"scene_ref_spec/2"},{"id":"sector/3","anchor":"sector/3"},{"id":"sector_spec/2","anchor":"sector_spec/2"},{"id":"text/3","anchor":"text/3"},{"id":"text_spec/2","anchor":"text_spec/2"},{"id":"triangle/3","anchor":"triangle/3"},{"id":"triangle_spec/2","anchor":"triangle_spec/2"},{"id":"update_opts/2","anchor":"update_opts/2"}]}]},{"id":"Scenic.Scene","title":"Scenic.Scene","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"response_opts/0","anchor":"t:response_opts/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"cast/2","anchor":"cast/2"},{"id":"cast_to_refs/2","anchor":"cast_to_refs/2"},{"id":"handle_call/3","anchor":"handle_call/3"},{"id":"handle_cast/2","anchor":"handle_cast/2"},{"id":"internal_push_graph/3","anchor":"internal_push_graph/3"},{"id":"send_event/2","anchor":"send_event/2"},{"id":"terminate/2","anchor":"terminate/2"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"filter_event/3","anchor":"c:filter_event/3"},{"id":"handle_call/3","anchor":"c:handle_call/3"},{"id":"handle_cast/2","anchor":"c:handle_cast/2"},{"id":"handle_continue/2","anchor":"c:handle_continue/2"},{"id":"handle_info/2","anchor":"c:handle_info/2"},{"id":"handle_input/3","anchor":"c:handle_input/3"},{"id":"init/2","anchor":"c:init/2"},{"id":"terminate/2","anchor":"c:terminate/2"}]}]},{"id":"Scenic.ViewPort","title":"Scenic.ViewPort","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"event/0","anchor":"t:event/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"capture_input/2","anchor":"capture_input/2"},{"id":"driver_cast/2","anchor":"driver_cast/2"},{"id":"info/1","anchor":"info/1"},{"id":"input/2","anchor":"input/2"},{"id":"input/3","anchor":"input/3"},{"id":"release_input/2","anchor":"release_input/2"},{"id":"request_root/2","anchor":"request_root/2"},{"id":"reset/1","anchor":"reset/1"},{"id":"reshape/2","anchor":"reshape/2"},{"id":"set_root/3","anchor":"set_root/3"},{"id":"start/1","anchor":"start/1"},{"id":"stop/1","anchor":"stop/1"}]}]},{"id":"Scenic.Component","title":"Scenic.Component","group":"Components","nodeGroups":[{"key":"callbacks","name":"Callbacks","nodes":[{"id":"add_to_graph/3","anchor":"c:add_to_graph/3"},{"id":"info/1","anchor":"c:info/1"},{"id":"verify/1","anchor":"c:verify/1"}]}]},{"id":"Scenic.Component.Button","title":"Scenic.Component.Button","group":"Components","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"}]}]},{"id":"Scenic.Component.Input.Caret","title":"Scenic.Component.Input.Caret","group":"Components","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"}]}]},{"id":"Scenic.Component.Input.Checkbox","title":"Scenic.Component.Input.Checkbox","group":"Components","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"}]}]},{"id":"Scenic.Component.Input.Dropdown","title":"Scenic.Component.Input.Dropdown","group":"Components","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"}]}]},{"id":"Scenic.Component.Input.RadioButton","title":"Scenic.Component.Input.RadioButton","group":"Components","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"}]}]},{"id":"Scenic.Component.Input.RadioGroup","title":"Scenic.Component.Input.RadioGroup","group":"Components","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"}]}]},{"id":"Scenic.Component.Input.Slider","title":"Scenic.Component.Input.Slider","group":"Components","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"}]}]},{"id":"Scenic.Component.Input.TextField","title":"Scenic.Component.Input.TextField","group":"Components","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"}]}]},{"id":"Scenic.Component.Input.Toggle","title":"Scenic.Component.Input.Toggle","group":"Components","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add_to_graph/3","anchor":"add_to_graph/3"}]}]},{"id":"Scenic.Primitive","title":"Scenic.Primitive","group":"Primitives","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"build/3","anchor":"build/3"},{"id":"contains_point?/2","anchor":"contains_point?/2"},{"id":"delete_style/2","anchor":"delete_style/2"},{"id":"delete_transform/2","anchor":"delete_transform/2"},{"id":"do_put/2","anchor":"do_put/2"},{"id":"get/1","anchor":"get/1"},{"id":"get_style/3","anchor":"get_style/3"},{"id":"get_styles/1","anchor":"get_styles/1"},{"id":"get_transform/3","anchor":"get_transform/3"},{"id":"get_transforms/1","anchor":"get_transforms/1"},{"id":"merge_opts/2","anchor":"merge_opts/2"},{"id":"put/3","anchor":"put/3"},{"id":"put_style/3","anchor":"put_style/3"},{"id":"put_styles/2","anchor":"put_styles/2"},{"id":"put_transform/3","anchor":"put_transform/3"},{"id":"put_transforms/2","anchor":"put_transforms/2"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"add_to_graph/3","anchor":"c:add_to_graph/3"},{"id":"contains_point?/2","anchor":"c:contains_point?/2"},{"id":"default_pin/1","anchor":"c:default_pin/1"},{"id":"expand/1","anchor":"c:expand/1"},{"id":"filter_styles/1","anchor":"c:filter_styles/1"},{"id":"info/1","anchor":"c:info/1"},{"id":"valid_styles/0","anchor":"c:valid_styles/0"},{"id":"verify/1","anchor":"c:verify/1"}]}]},{"id":"Scenic.Primitive.Arc","title":"Scenic.Primitive.Arc","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.Circle","title":"Scenic.Primitive.Circle","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.Ellipse","title":"Scenic.Primitive.Ellipse","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.Group","title":"Scenic.Primitive.Group","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"delete/2","anchor":"delete/2"},{"id":"increment/2","anchor":"increment/2"},{"id":"insert_at/3","anchor":"insert_at/3"},{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.Line","title":"Scenic.Primitive.Line","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"centroid/1","anchor":"centroid/1"},{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.Path","title":"Scenic.Primitive.Path","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.Quad","title":"Scenic.Primitive.Quad","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"expand/2","anchor":"expand/2"},{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.Rectangle","title":"Scenic.Primitive.Rectangle","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"centroid/1","anchor":"centroid/1"},{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.RoundedRectangle","title":"Scenic.Primitive.RoundedRectangle","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"centroid/1","anchor":"centroid/1"},{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.SceneRef","title":"Scenic.Primitive.SceneRef","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.Sector","title":"Scenic.Primitive.Sector","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.Text","title":"Scenic.Primitive.Text","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.Triangle","title":"Scenic.Primitive.Triangle","group":"Primitives","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"centroid/1","anchor":"centroid/1"},{"id":"valid_styles/0","anchor":"valid_styles/0"}]}]},{"id":"Scenic.Primitive.Style","title":"Scenic.Primitive.Style","group":"Styles","nodeGroups":[{"key":"callbacks","name":"Callbacks","nodes":[{"id":"info/1","anchor":"c:info/1"},{"id":"verify/1","anchor":"c:verify/1"}]}]},{"id":"Scenic.Primitive.Style.Cap","title":"Scenic.Primitive.Style.Cap","group":"Styles"},{"id":"Scenic.Primitive.Style.ClearColor","title":"Scenic.Primitive.Style.ClearColor","group":"Styles"},{"id":"Scenic.Primitive.Style.Fill","title":"Scenic.Primitive.Style.Fill","group":"Styles"},{"id":"Scenic.Primitive.Style.Font","title":"Scenic.Primitive.Style.Font","group":"Styles"},{"id":"Scenic.Primitive.Style.FontBlur","title":"Scenic.Primitive.Style.FontBlur","group":"Styles"},{"id":"Scenic.Primitive.Style.FontSize","title":"Scenic.Primitive.Style.FontSize","group":"Styles"},{"id":"Scenic.Primitive.Style.Hidden","title":"Scenic.Primitive.Style.Hidden","group":"Styles"},{"id":"Scenic.Primitive.Style.Join","title":"Scenic.Primitive.Style.Join","group":"Styles"},{"id":"Scenic.Primitive.Style.MiterLimit","title":"Scenic.Primitive.Style.MiterLimit","group":"Styles"},{"id":"Scenic.Primitive.Style.Scissor","title":"Scenic.Primitive.Style.Scissor","group":"Styles"},{"id":"Scenic.Primitive.Style.Stroke","title":"Scenic.Primitive.Style.Stroke","group":"Styles"},{"id":"Scenic.Primitive.Style.TextAlign","title":"Scenic.Primitive.Style.TextAlign","group":"Styles"},{"id":"Scenic.Primitive.Style.TextHeight","title":"Scenic.Primitive.Style.TextHeight","group":"Styles"},{"id":"Scenic.Primitive.Style.Theme","title":"Scenic.Primitive.Style.Theme","group":"Styles"},{"id":"Scenic.Primitive.Style.Paint","title":"Scenic.Primitive.Style.Paint","group":"Style.Paint"},{"id":"Scenic.Primitive.Style.Paint.BoxGradient","title":"Scenic.Primitive.Style.Paint.BoxGradient","group":"Style.Paint"},{"id":"Scenic.Primitive.Style.Paint.Color","title":"Scenic.Primitive.Style.Paint.Color","group":"Style.Paint","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"rgb/0","anchor":"t:rgb/0"},{"id":"rgba/0","anchor":"t:rgba/0"},{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"name_to_rgb/1","anchor":"name_to_rgb/1"},{"id":"to_rgba/1","anchor":"to_rgba/1"},{"id":"verify/1","anchor":"verify/1"}]}]},{"id":"Scenic.Primitive.Style.Paint.Dynamic","title":"Scenic.Primitive.Style.Paint.Dynamic","group":"Style.Paint"},{"id":"Scenic.Primitive.Style.Paint.Image","title":"Scenic.Primitive.Style.Paint.Image","group":"Style.Paint"},{"id":"Scenic.Primitive.Style.Paint.LinearGradient","title":"Scenic.Primitive.Style.Paint.LinearGradient","group":"Style.Paint"},{"id":"Scenic.Primitive.Style.Paint.RadialGradient","title":"Scenic.Primitive.Style.Paint.RadialGradient","group":"Style.Paint"},{"id":"Scenic.Primitive.Transform","title":"Scenic.Primitive.Transform","group":"Transforms","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"calculate_local/1","anchor":"calculate_local/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"info/1","anchor":"c:info/1"},{"id":"verify/1","anchor":"c:verify/1"}]}]},{"id":"Scenic.Primitive.Transform.Matrix","title":"Scenic.Primitive.Transform.Matrix","group":"Transforms"},{"id":"Scenic.Primitive.Transform.Pin","title":"Scenic.Primitive.Transform.Pin","group":"Transforms"},{"id":"Scenic.Primitive.Transform.Rotate","title":"Scenic.Primitive.Transform.Rotate","group":"Transforms"},{"id":"Scenic.Primitive.Transform.Scale","title":"Scenic.Primitive.Transform.Scale","group":"Transforms"},{"id":"Scenic.Primitive.Transform.Translate","title":"Scenic.Primitive.Transform.Translate","group":"Transforms"},{"id":"Scenic.Math","title":"Scenic.Math","group":"Math","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"line/0","anchor":"t:line/0"},{"id":"matrix/0","anchor":"t:matrix/0"},{"id":"matrix_list/0","anchor":"t:matrix_list/0"},{"id":"point/0","anchor":"t:point/0"},{"id":"quad/0","anchor":"t:quad/0"},{"id":"triangle/0","anchor":"t:triangle/0"},{"id":"vector_2/0","anchor":"t:vector_2/0"}]}]},{"id":"Scenic.Math.Line","title":"Scenic.Math.Line","group":"Math","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"intersection/2","anchor":"intersection/2"},{"id":"parallel/2","anchor":"parallel/2"},{"id":"round/1","anchor":"round/1"},{"id":"trunc/1","anchor":"trunc/1"}]}]},{"id":"Scenic.Math.Matrix","title":"Scenic.Math.Matrix","group":"Math","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add/2","anchor":"add/2"},{"id":"adjugate/1","anchor":"adjugate/1"},{"id":"build_rotate_around/2","anchor":"build_rotate_around/2"},{"id":"build_rotation/1","anchor":"build_rotation/1"},{"id":"build_scale/1","anchor":"build_scale/1"},{"id":"build_translation/1","anchor":"build_translation/1"},{"id":"close?/3","anchor":"close?/3"},{"id":"determinant/1","anchor":"determinant/1"},{"id":"div/2","anchor":"div/2"},{"id":"get/3","anchor":"get/3"},{"id":"get_xy/1","anchor":"get_xy/1"},{"id":"identity/0","anchor":"identity/0"},{"id":"invert/1","anchor":"invert/1"},{"id":"mul/1","anchor":"mul/1"},{"id":"mul/2","anchor":"mul/2"},{"id":"project_vector/2","anchor":"project_vector/2"},{"id":"project_vectors/2","anchor":"project_vectors/2"},{"id":"put/4","anchor":"put/4"},{"id":"rotate/2","anchor":"rotate/2"},{"id":"scale/2","anchor":"scale/2"},{"id":"sub/2","anchor":"sub/2"},{"id":"translate/2","anchor":"translate/2"},{"id":"transpose/1","anchor":"transpose/1"},{"id":"zero/0","anchor":"zero/0"}]}]},{"id":"Scenic.Math.Matrix.Utils","title":"Scenic.Math.Matrix.Utils","group":"Math","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"to_binary/1","anchor":"to_binary/1"},{"id":"to_list/1","anchor":"to_list/1"}]}]},{"id":"Scenic.Math.Vector2","title":"Scenic.Math.Vector2","group":"Math","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"add/2","anchor":"add/2"},{"id":"clamp/3","anchor":"clamp/3"},{"id":"cross/2","anchor":"cross/2"},{"id":"distance/2","anchor":"distance/2"},{"id":"distance_squared/2","anchor":"distance_squared/2"},{"id":"div/2","anchor":"div/2"},{"id":"dot/2","anchor":"dot/2"},{"id":"down/0","anchor":"down/0"},{"id":"in_bounds?/2","anchor":"in_bounds?/2"},{"id":"in_bounds?/3","anchor":"in_bounds?/3"},{"id":"invert/1","anchor":"invert/1"},{"id":"left/0","anchor":"left/0"},{"id":"length/1","anchor":"length/1"},{"id":"length_squared/1","anchor":"length_squared/1"},{"id":"lerp/3","anchor":"lerp/3"},{"id":"max/2","anchor":"max/2"},{"id":"min/2","anchor":"min/2"},{"id":"mul/2","anchor":"mul/2"},{"id":"nlerp/3","anchor":"nlerp/3"},{"id":"normalize/1","anchor":"normalize/1"},{"id":"one/0","anchor":"one/0"},{"id":"project/2","anchor":"project/2"},{"id":"right/0","anchor":"right/0"},{"id":"round/1","anchor":"round/1"},{"id":"sub/2","anchor":"sub/2"},{"id":"trunc/1","anchor":"trunc/1"},{"id":"unity_x/0","anchor":"unity_x/0"},{"id":"unity_y/0","anchor":"unity_y/0"},{"id":"up/0","anchor":"up/0"},{"id":"zero/0","anchor":"zero/0"}]}]},{"id":"Scenic.ViewPort.Config","title":"Scenic.ViewPort.Config","group":"ViewPort","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"valid!/1","anchor":"valid!/1"},{"id":"valid?/1","anchor":"valid?/1"}]}]},{"id":"Scenic.ViewPort.Input","title":"Scenic.ViewPort.Input","group":"ViewPort","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"class/0","anchor":"t:class/0"},{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"handle_cast/2","anchor":"handle_cast/2"}]}]},{"id":"Scenic.ViewPort.Tables","title":"Scenic.ViewPort.Tables","group":"ViewPort","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"delete_graph/1","anchor":"delete_graph/1"},{"id":"get_graph/1","anchor":"get_graph/1"},{"id":"get_graph_refs/1","anchor":"get_graph_refs/1"},{"id":"get_refs/1","anchor":"get_refs/1"},{"id":"insert_graph/4","anchor":"insert_graph/4"},{"id":"subscribe/2","anchor":"subscribe/2"},{"id":"unsubscribe/2","anchor":"unsubscribe/2"}]}]},{"id":"Scenic.ViewPort.Driver","title":"Scenic.ViewPort.Driver","group":"Drivers","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"init/1","anchor":"init/1"},{"id":"start/2","anchor":"start/2"},{"id":"start_link/1","anchor":"start_link/1"},{"id":"stop/1","anchor":"stop/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"handle_call/3","anchor":"c:handle_call/3"},{"id":"handle_cast/2","anchor":"c:handle_cast/2"},{"id":"handle_info/2","anchor":"c:handle_info/2"},{"id":"init/3","anchor":"c:init/3"}]}]},{"id":"Scenic.ViewPort.Driver.Config","title":"Scenic.ViewPort.Driver.Config","group":"Drivers","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"valid!/1","anchor":"valid!/1"},{"id":"valid?/1","anchor":"valid?/1"}]}]},{"id":"Scenic.ViewPort.Driver.Info","title":"Scenic.ViewPort.Driver.Info","group":"Drivers"},{"id":"Scenic.Cache.Base","title":"Scenic.Cache.Base","group":"Cache","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"hash/0","anchor":"t:hash/0"},{"id":"sub_types/0","anchor":"t:sub_types/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"claim/3","anchor":"claim/3"},{"id":"claimed?/3","anchor":"claimed?/3"},{"id":"fetch/2","anchor":"fetch/2"},{"id":"get/3","anchor":"get/3"},{"id":"get!/2","anchor":"get!/2"},{"id":"keys/2","anchor":"keys/2"},{"id":"member?/2","anchor":"member?/2"},{"id":"put/4","anchor":"put/4"},{"id":"release/3","anchor":"release/3"},{"id":"status/3","anchor":"status/3"},{"id":"subscribe/3","anchor":"subscribe/3"},{"id":"unsubscribe/3","anchor":"unsubscribe/3"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"load/3","anchor":"c:load/3"},{"id":"load!/3","anchor":"c:load!/3"}]}]},{"id":"Scenic.Cache.Dynamic.Texture","title":"Scenic.Cache.Dynamic.Texture","group":"Cache","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"claim/2","anchor":"claim/2"},{"id":"claimed?/2","anchor":"claimed?/2"},{"id":"fetch/1","anchor":"fetch/1"},{"id":"get/2","anchor":"get/2"},{"id":"get!/1","anchor":"get!/1"},{"id":"keys/1","anchor":"keys/1"},{"id":"member?/1","anchor":"member?/1"},{"id":"put/3","anchor":"put/3"},{"id":"put_new/3","anchor":"put_new/3"},{"id":"release/2","anchor":"release/2"},{"id":"status/2","anchor":"status/2"},{"id":"subscribe/2","anchor":"subscribe/2"},{"id":"unsubscribe/2","anchor":"unsubscribe/2"}]}]},{"id":"Scenic.Cache.Hash","title":"Scenic.Cache.Hash","group":"Cache","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"binary/2","anchor":"binary/2"},{"id":"binary!/2","anchor":"binary!/2"},{"id":"file/2","anchor":"file/2"},{"id":"file!/2","anchor":"file!/2"},{"id":"verify/3","anchor":"verify/3"},{"id":"verify!/3","anchor":"verify!/3"},{"id":"verify_file/3","anchor":"verify_file/3"},{"id":"verify_file!/3","anchor":"verify_file!/3"}]}]},{"id":"Scenic.Cache.Static.Font","title":"Scenic.Cache.Static.Font","group":"Cache","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"claim/2","anchor":"claim/2"},{"id":"claimed?/2","anchor":"claimed?/2"},{"id":"fetch/1","anchor":"fetch/1"},{"id":"get/2","anchor":"get/2"},{"id":"get!/1","anchor":"get!/1"},{"id":"keys/1","anchor":"keys/1"},{"id":"load/3","anchor":"load/3"},{"id":"load!/3","anchor":"load!/3"},{"id":"member?/1","anchor":"member?/1"},{"id":"put_new/3","anchor":"put_new/3"},{"id":"release/2","anchor":"release/2"},{"id":"status/2","anchor":"status/2"},{"id":"subscribe/2","anchor":"subscribe/2"},{"id":"unsubscribe/2","anchor":"unsubscribe/2"}]}]},{"id":"Scenic.Cache.Static.FontMetrics","title":"Scenic.Cache.Static.FontMetrics","group":"Cache","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"sys_fonts/0","anchor":"t:sys_fonts/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"claim/2","anchor":"claim/2"},{"id":"claimed?/2","anchor":"claimed?/2"},{"id":"fetch/1","anchor":"fetch/1"},{"id":"get/2","anchor":"get/2"},{"id":"get!/1","anchor":"get!/1"},{"id":"keys/1","anchor":"keys/1"},{"id":"load/3","anchor":"load/3"},{"id":"load!/3","anchor":"load!/3"},{"id":"member?/1","anchor":"member?/1"},{"id":"put_new/3","anchor":"put_new/3"},{"id":"release/2","anchor":"release/2"},{"id":"status/2","anchor":"status/2"},{"id":"subscribe/2","anchor":"subscribe/2"},{"id":"unsubscribe/2","anchor":"unsubscribe/2"}]}]},{"id":"Scenic.Cache.Static.Texture","title":"Scenic.Cache.Static.Texture","group":"Cache","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"claim/2","anchor":"claim/2"},{"id":"claimed?/2","anchor":"claimed?/2"},{"id":"fetch/1","anchor":"fetch/1"},{"id":"get/2","anchor":"get/2"},{"id":"get!/1","anchor":"get!/1"},{"id":"keys/1","anchor":"keys/1"},{"id":"load/3","anchor":"load/3"},{"id":"load!/3","anchor":"load!/3"},{"id":"member?/1","anchor":"member?/1"},{"id":"put_new/3","anchor":"put_new/3"},{"id":"release/2","anchor":"release/2"},{"id":"status/2","anchor":"status/2"},{"id":"subscribe/2","anchor":"subscribe/2"},{"id":"unsubscribe/2","anchor":"unsubscribe/2"}]}]},{"id":"Scenic.Cache.Support.File","title":"Scenic.Cache.Support.File","group":"Cache","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"read/3","anchor":"read/3"},{"id":"read!/3","anchor":"read!/3"}]}]},{"id":"Scenic.Cache.Support.Hash","title":"Scenic.Cache.Support.Hash","group":"Cache","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"hash_type/0","anchor":"t:hash_type/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"binary/2","anchor":"binary/2"},{"id":"binary!/2","anchor":"binary!/2"},{"id":"file/2","anchor":"file/2"},{"id":"file!/2","anchor":"file!/2"},{"id":"verify/3","anchor":"verify/3"},{"id":"verify!/3","anchor":"verify!/3"},{"id":"verify_file/3","anchor":"verify_file/3"},{"id":"verify_file!/3","anchor":"verify_file!/3"}]}]},{"id":"Scenic.Cache.Support.Supervisor","title":"Scenic.Cache.Support.Supervisor","group":"Cache","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"start_link/0","anchor":"start_link/0"}]}]},{"id":"Scenic.Utilities.Texture","title":"Scenic.Utilities.Texture","group":"Utilities","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"build/4","anchor":"build/4"},{"id":"build!/4","anchor":"build!/4"},{"id":"clear!/2","anchor":"clear!/2"},{"id":"get/3","anchor":"get/3"},{"id":"put!/4","anchor":"put!/4"},{"id":"to_rgba/1","anchor":"to_rgba/1"}]}]}],"tasks":[{"id":"Mix.Tasks.Scenic.Hash","title":"scenic.hash","group":""},{"id":"Mix.Tasks.Scenic.Run","title":"scenic.run","group":""}]}